"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useUNSAFECatalog = exports.useCatalog = void 0;

var _react = _interopRequireDefault(require("react"));

var _utils = require("../utils");

var _catalogContext = _interopRequireDefault(require("./catalog-context"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const useCatalog = () => {
  const catalog = _react.default.useContext(_catalogContext.default);

  if (!(0, _utils.isValidCatalog)(catalog)) {
    if (process.env.NODE_ENV !== "production") {
      console.error('[useCatalog] You are not using useCatalog in the context of a CatalogProvider with a proper catalog.');
    }

    return null;
  }

  return catalog;
};

exports.useCatalog = useCatalog;

const useUNSAFECatalog = () => _react.default.useContext(_catalogContext.default);

exports.useUNSAFECatalog = useUNSAFECatalog;