"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.withCatalog = exports.getDisplayName = void 0;

var _react = _interopRequireDefault(require("react"));

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

var _utils = require("../utils");

var _useCatalog = require("./use-catalog");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const getDisplayName = Component => {
  return Component.displayName || Component.name || 'Component';
};

exports.getDisplayName = getDisplayName;

const withCatalog = Component => {
  const WithCatalog = _react.default.forwardRef((props, ref) => {
    const catalog = (0, _useCatalog.useUNSAFECatalog)();

    if (!(0, _utils.isValidCatalog)(catalog)) {
      if (process.env.NODE_ENV !== "production") {
        console.error('[withCatalog] You are not using withCatalog in the context of a CatalogProvider with a proper catalog.');
      }
    }

    return _react.default.createElement(Component, _extends({}, props, {
      catalog: catalog,
      ref: ref
    }));
  });

  WithCatalog.displayName = `WithCatalog(${getDisplayName(Component)})`;
  (0, _hoistNonReactStatics.default)(WithCatalog, Component, undefined);
  return WithCatalog;
};

exports.withCatalog = withCatalog;
var _default = withCatalog;
exports.default = _default;