import React, { PropsWithChildren } from 'react';
import { CatalogComponents } from '../types';
interface IProps<T extends Record<string, any> = CatalogComponents> {
    catalog: T;
    catalogPrefix?: string;
}
/**
 * Provide the `catalog` to an entire react component tree. Read more about
 * React context here: https://reactjs.org/docs/context.html
 */
declare const CatalogProvider: {
    <T extends Record<string, any> = CatalogComponents>(props: React.PropsWithChildren<IProps<T>>): JSX.Element;
    defaultProps: Partial<IProps<CatalogComponents>>;
};
export default CatalogProvider;
//# sourceMappingURL=catalog-provider.d.ts.map