"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isValidCatalog = exports.get = void 0;

var _catalog = _interopRequireDefault(require("./catalog"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const get = (obj, path, def) => {
  const stringToPath = pathValue => {
    if (typeof pathValue !== 'string') {
      if (Array.isArray(pathValue)) {
        return pathValue;
      }

      return null;
    }

    const output = [];
    pathValue.split('.').forEach(item => {
      item.split(/\[([^}]+)\]/g).forEach(key => {
        if (key.length > 0) {
          output.push(key);
        }
      });
    });
    return output;
  };

  const findPath = stringToPath(path);

  if (!findPath) {
    return def;
  }

  let current = obj;

  for (let i = 0; i < findPath.length; i++) {
    if (!current[findPath[i]]) {
      return def;
    }

    current = current[findPath[i]];
  }

  return current;
};

exports.get = get;

const isValidCatalog = catalog => catalog && catalog instanceof _catalog.default;

exports.isValidCatalog = isValidCatalog;