import React, { ComponentType } from 'react';
export declare const getDisplayName: (Component: ComponentType) => string;
/**
 * withCatalog will connect to the CatalogProvider (Context) and pass the
 * current catalog to the Component
 *
 * inspired by:
 * - https://github.com/styled-components/styled-components/blob/df2c947e0a2a61e739b391cd8a47a787a56f6f5b/packages/styled-components/src/hoc/withTheme.js
 */
export declare const withCatalog: (Component: ComponentType<any>) => React.ForwardRefExoticComponent<Pick<any, string | number | symbol> & React.RefAttributes<unknown>>;
export default withCatalog;
//# sourceMappingURL=with-catalog.d.ts.map