"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _catalog = _interopRequireDefault(require("../catalog"));

var _catalogContext = _interopRequireDefault(require("./catalog-context"));

var _useCatalog = require("./use-catalog");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var CatalogProvider = function CatalogProvider(props) {
  var catalog = props.catalog,
      catalogPrefix = props.catalogPrefix,
      children = props.children;
  var outerCatalog = (0, _useCatalog.useUNSAFECatalog)();

  if (!catalog) {
    if (process.env.NODE_ENV !== "production") {
      console.error('[CatalogProvider] must be rendered with a valid catalog property');
    }

    return null;
  }

  if (!children) {
    if (process.env.NODE_ENV !== "production") {
      console.error('[CatalogProvider] must contain at least one child');
    }

    return null;
  }

  var prefixedCatalog = {};

  if (catalog && catalogPrefix) {
    Object.keys(catalog).forEach(function (c) {
      var cE = c;
      prefixedCatalog["".concat(catalogPrefix).concat(cE)] = catalog[cE];
    });
  }

  var newCatalog = _objectSpread(_objectSpread({}, outerCatalog && outerCatalog._catalog), catalogPrefix && prefixedCatalog || catalog);

  var prepCatalog = new _catalog["default"](newCatalog);
  return _react["default"].createElement(_catalogContext["default"].Provider, {
    value: prepCatalog
  }, _react["default"].Children.only(children));
};

CatalogProvider.defaultProps = {
  catalogPrefix: '',
  catalog: undefined
};
var _default = CatalogProvider;
exports["default"] = _default;